#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <windows.h>

extern int manual, manual2;
extern "C" int DebugOutput;
extern int RuntimeOutput;
extern int ChooseClass;
extern int calctype, adverror, loop;

extern int randstackinit;
extern int randstacktmp;
extern int randstack;
extern int arandstack;

extern bool UseIsaac;

extern void quitprog(bool save = true);
extern unsigned int intpart(unsigned int val, unsigned int part);

extern unsigned int isaacrand(unsigned int Min, unsigned int Max, bool Init = false, unsigned long int* seed = NULL);

int radr;
int useagain[BufferLen];
int useagaincount = 0;
int useagainaddr[BufferLen];

char tempscanstr[256];
char* tempscanstra;
int usei;
int savethis = 0;

extern int reproduce;
extern int readreproducea;

extern unsigned int* retemp;
extern unsigned int* prepos;

extern FILE* reRead;
char rebuf[16];

int skipped, skipped2;
int nonefound;

int arandchild = 0;

int manualinrand;

unsigned int random(int min, int max, char* Text, int OverrideManual = 0)
{
#ifndef noasm
	__asm
	{
		cmp randstackinit, 1
		jne norandstackinit

		mov eax, randstacktmp
		sub eax, esp
		mov randstack, eax

norandstackinit:

		mov ebx, esp
		add ebx, randstack
		mov eax, ss:[ebx - 4]
		mov radr, eax
	}
#endif

	if (randstackinit)
	{
		return(0);
	}

	if (min == max)
	{
		return(min);
	}

	unsigned int temp = 0, temp2, temp3, i, j;
	int stemp = 0;

	if (OverrideManual == -1 || Text[0] == 0)
	{
		manualinrand = 0;
		OverrideManual = 0;
	}
	else
	{
		manualinrand = manual;
	}

	if (UseIsaac)
	{
		return(isaacrand(min, max));
	}

	skipped = 0;
	nonefound = 0;

	if (readreproducea)
	{
		if (feof(reRead))
		{
			readreproducea = 0;
			goto skiprep;
		}
		fgets(rebuf, 256, reRead);
		if (rebuf[0] == 10 || rebuf[0] == 13)
		{
			readreproducea = 0;
			goto skiprep;
		}
		sscanf(rebuf, "%d\n", &retemp[*prepos]);
		(*prepos)++;
		adverror = 1;
		return(retemp[*prepos - 1]);
	}
skiprep:

	if (manualinrand || DebugOutput || OverrideManual)
	{
		printf("\n-------------------------------------------------------------------------------\nManuel Random (%s):\nBitte Zahl zwischen %d und %d eingeben!   ", Text, min, max);
		if (RuntimeOutput || DebugOutput == 0)
		{
			printf("\n(Called from %d)   :", radr);
		}
	}

rescan:
	skipped2 = 0;
	for (usei = 0;usei < useagaincount;usei++)
	{
		if (useagainaddr[usei] == radr)
		{
			if (skipped2 == skipped)
			{
				stemp = useagain[usei];
				goto scandone;
			}
			else
			{
				skipped2++;
			}
		}
	}
	nonefound = 1;
	
	if (manualinrand || OverrideManual)
	{
		do
		{
			if (nonefound == 0)
			{
				skipped++;
				goto rescan;
			}
			savethis = 0;
			scanf("%s", tempscanstr);
			if (tempscanstr[0] == 42)
			{
#ifdef noasm
				printf("* NOT SUPPORTED IN THIS RUNTIME\n");
#else
				savethis = 1;
#endif
				tempscanstra = tempscanstr + 1;
			}
			else
			{
				tempscanstra = tempscanstr;
			}
				
			stemp = atoi(tempscanstra);
			
scandone:
			if (stemp < 0)
			{
				if (savethis)
				{
					useagain[useagaincount] = stemp;
					useagainaddr[useagaincount] = radr;
					useagaincount++;
					savethis = 0;
				}
				goto autorandom;
			}
		} while (stemp < min || stemp > max);
		if (savethis)
		{
			useagain[useagaincount] = stemp;
			useagainaddr[useagaincount] = radr;
			useagaincount++;
			savethis = 0;
		}
		if (reproduce == 1 && arandchild == 0)
		{
			retemp[*prepos] = stemp;
			(*prepos)++;
		}
		return(stemp);
	}

autorandom:;
	if (stemp == -1) {manual = 0;}
	if (stemp == -2) {manual = 0;manual2 = 0;ChooseClass = 0;}

	for (i = 0;i < 8;i++)
	{
		temp *= 16;
		temp2 = 0;
		for (j = 1;j <= 4;j++)
		{
			temp3 = intpart(rand(), j);
			temp2 ^= temp3;
		}
		temp += temp2;
	}
	temp = (signed) (temp % (max - min + 1)) + min;
	if (reproduce == 1 && arandchild == 0)
	{
		retemp[*prepos] = temp;
		(*prepos)++;
	}
	return(temp);
}

int aradr;
int auseagain[BufferLen];
int auseagaincount = 0;
int auseagainaddr[BufferLen];

char atempscanstr[256];
char* atempscanstra;
int ausei;
int asavethis = 0;

int AdvancedRand(int number, const int* firstval, int jump, const char* Text, int TextJump, char* Text2, int OverrideManual = 0, int TextPointer = 0)
{
#ifndef noasm
	__asm
	{
		cmp randstackinit, 1
		jne noarandstackinit

		mov eax, randstacktmp
		sub eax, esp
		mov arandstack, eax

noarandstackinit:

		mov ebx, esp
		add ebx, arandstack
		mov eax, ss:[ebx - 4]
		mov aradr, eax
	}
#endif

	if (randstackinit)
	{
		return(0);
	}

	if (number == 1)
	{
		return(0);
	}
	
	int addval = 0, tempval = 0, tempval2;
	int* curval;
	int* tempvals;
	int i;

	int realnumber, realnumbercur;

	int maxval = 1;
	int highestval = 0;
	skipped = 0;
	nonefound = 0;

	if (OverrideManual == -1  || (TextPointer == 0 ? Text : (*((char**) Text)))[0] == 0 )
	{
		manualinrand = 0;
		OverrideManual = 0;
	}
	else
	{
		manualinrand = manual;
	}

	if (readreproducea)
	{
		if (feof(reRead))
		{
			readreproducea = 0;
			goto askiprep;
		}
		fgets(rebuf, 256, reRead);
		if (rebuf[0] == 10 || rebuf[0] == 13)
		{
			readreproducea = 0;
			goto askiprep;
		}
		sscanf(rebuf, "%d\n", &retemp[*prepos]);
		(*prepos)++;
		adverror = 1;
		return((signed) retemp[*prepos - 1]);
	}
askiprep:

	tempvals = (int*) mallocl(number * sizeof(int), "AdvancedRand-tempvals");
	if (tempvals == 0)
	{
		printf("Memmory Allocation Error\n");
		quitprog();
	}

	if (calctype == 1 || calctype == 2)
	{
		for (i = 0;i < number;i++)
		{
			curval = (int*) (((char*) firstval) + i * jump);
			if (*curval > maxval)
			{
				maxval = *curval;
				highestval = i;
			}
		}
	}

	if (calctype == 2 && OverrideManual == 0 && manual == 0)
	{
		if (reproduce == 1)
		{
			retemp[*prepos] = highestval;
			(*prepos)++;
		}
		freel(tempvals);
		return(highestval);
	}

	if (maxval > 15000)
	{
		maxval = max(1, maxval / 30000);
	}
	else
	{
		maxval = 1;
	}

	realnumber = 0;
	for (i = 0;i < number;i++)
	{
		curval = (int*) (((char*) firstval) + i * jump);
		tempval2 = *curval;
		tempval2 /= maxval;
		if (calctype == 1)
		{
			tempval2 *= tempval2;
		}
		if (calctype == -1)
		{
			tempval2 = (int) sqrt(tempval2);
		}
		if (*curval >= 0)
		{
			realnumber++;
			realnumbercur = i;
			addval += tempval2;
		}
		else
		{
			printf("Negative Probability...\n");
			quitprog();
			freel(tempvals);
			return(-2);
		}
		tempvals[i] = addval;
	}

	if (realnumber == 1)
	{
		freel(tempvals);
		return(realnumbercur);
	}

	if (addval == 0)
	{
		if (adverror == 0)
		{
			adverror = 1;
		}
		else
		{
			loop = 0;
			printf("No Probability given\n");
			quitprog();
		}
		if (reproduce == 1)
		{
			retemp[*prepos] = (unsigned) -1;
			(*prepos)++;
		}
		freel(tempvals);
		if (manualinrand || DebugOutput || OverrideManual)
		{
			printf("Rckgabe -1 da keine wahrscheinlichkeit\n");
		}
		return(-1);
	}
	adverror = 1;

	if (manualinrand || DebugOutput || OverrideManual)
	{
		printf("\n-------------------------------------------------------------------------------\nManuel AdvancedRand\n");
		printf("(%s:)\n", Text2);
		if (RuntimeOutput || DebugOutput == 0)
		{
			printf("(Called from %d)\n", aradr);
		}
		for (i = 0;i < number;i++)
		{
			if (*((int*) (((char*) firstval) + i * jump)) > 0)
			{
				if (calctype == 1)
				{
					printf("%d: (%d / %d): %s\n", i, (*((int*) (((char*) firstval) + i * jump)) /= maxval) * (*((int*) (((char*) firstval) + i * jump)) /= maxval), addval, (TextPointer == 0 ? Text + i * TextJump : (*((char**) (Text + i * TextJump)))));
				}
				else if (calctype == -1)
				{
					printf("%d: (%d / %d): %s\n", i, (int) sqrt(*((int*) (((char*) firstval) + i * jump))), addval, (TextPointer == 0 ? Text + i * TextJump : (*((char**) (Text + i * TextJump)))));
				}
				else
				{
					printf("%d: (%d / %d): %s\n", i, *((int*) (((char*) firstval) + i * jump)), addval, (TextPointer == 0 ? Text + i * TextJump : (*((char**) (Text + i * TextJump)))));
				}
			}
		}
	}

arescan:
	skipped2 = 0;
	for (ausei = 0;ausei < auseagaincount;ausei++)
	{
		if (auseagainaddr[ausei] == aradr)
		{
			if (skipped2 == skipped)
			{
				tempval = auseagain[ausei];
				goto ascandone;
			}
			else
			{
				skipped2++;
			}
		}
	}
	nonefound = 1;
	
	if (manualinrand || OverrideManual)
	{
		do
		{
			if (nonefound == 0)
			{
				skipped++;
				goto arescan;
			}
			asavethis = 0;
			scanf("%s", atempscanstr);
			if (atempscanstr[0] == 42)
			{
#ifdef noasm
				printf("* NOT SUPPORTED IN THIS RUNTIME\n");
#else
				asavethis = 1;
#endif
				atempscanstra = atempscanstr + 1;
			}
			else
			{
				atempscanstra = atempscanstr;
			}

			tempval = atoi(atempscanstra);
			
ascandone:
			if (tempval < 0)
			{
				if (asavethis)
				{
					auseagain[auseagaincount] = tempval;
					auseagainaddr[auseagaincount] = aradr;
					auseagaincount++;
					asavethis = 0;
				}
				goto autoadvrand;
			}

		} while (tempval < 0 || tempval >= number || *((int*) (((char*) firstval) + tempval * jump)) <= 0);
		freel(tempvals);
		if (asavethis)
		{
			auseagain[auseagaincount] = tempval;
			auseagainaddr[auseagaincount] = aradr;
			auseagaincount++;
			asavethis = 0;
		}
		
		if (reproduce == 1)
		{
			retemp[*prepos] = tempval;
			(*prepos)++;
		}
		return(tempval);
	}

autoadvrand:;
	if (tempval == -1) {manual = 0;}
	if (tempval == -2) {manual = 0;manual2 = 0;ChooseClass = 0;}

	arandchild = 1;
	tempval = random(1, addval, "");
	arandchild = 0;

	for (i = 0;i < number;i++)
	{
		if (tempvals[i] >= tempval)
		{
			freel(tempvals);
			if (DebugOutput) {printf("Selected: %d\n", i);}
			if (reproduce == 1)
			{
				retemp[*prepos] = i;
				(*prepos)++;
			}
			return(i);
		}
	}
	freel(tempvals);
	return(0);
}
